openshot::Wave Class Reference

This class distorts an image using a wave pattern. More...

`#include <Wave.h>`

Inheritance diagram for openshot::Wave:

## Public Member Functions

std::shared_ptr< Frame > | GetFrame (std::shared_ptr< Frame > frame, int64_t frame_number)
| This method is required for all derived classes of EffectBase, and returns a modified openshot::Frame object. More...
std::string | Json () const override
| Get and Set JSON methods. More...
Json::Value | JsonValue () const override
| Generate Json::Value for this object. More...
std::string | PropertiesJSON (int64_t requested_frame) const override
void | SetJson (const std::string value)
| Load JSON string into this object. More...
void | SetJsonValue (const Json::Value root)
| Load Json::Value into this object. More...
| Wave ()
| Blank constructor, useful when using Json to load the effect properties. More...
| Wave (Keyframe wavelength, Keyframe amplitude, Keyframe multiplier, Keyframe shift_x, Keyframe speed_y)
Public Member Functions inherited from openshot::EffectBase
int | constrain (int color_value)
| Constrain a color value from 0 to 255. More...
void | DisplayInfo ()
| Display effect information in the standard output stream (stdout) More...
void | InitEffectInfo ()
Json::Value | JsonInfo () const
| Generate JSON object of meta data / info. More...
int | Order () const
| Get the order that this effect should be executed. More...
void | Order (int new_order)
| Set the order that this effect should be executed. More...
virtual | ~EffectBase ()=default
Public Member Functions inherited from openshot::ClipBase
| ClipBase ()
| Constructor for the base clip. More...
float | Duration () const
| Get the length of this clip (in seconds) More...
float | End () const
| Get end position (in seconds) of clip (trim end of video) More...
void | End (float value)
| Set end position (in seconds) of clip (trim end of video) More...
std::string | Id () const
| Get basic properties. More...
void | Id (std::string value)
| Set basic properties. More...
int | Layer () const
| Get layer of clip on timeline (lower number is covered by higher numbers) More...
void | Layer (int value)
| Set layer of clip on timeline (lower number is covered by higher numbers) More...
bool | operator< (ClipBase &a)
bool | operator<= (ClipBase &a)
bool | operator> (ClipBase &a)
bool | operator>= (ClipBase &a)
float | Position () const
| Get position on timeline (in seconds) More...
void | Position (float value)

> Set the Id of this clip object

More...

float | Start () const
| Get start position (in seconds) of clip (trim start of video) More...
void | Start (float value)
| Set start position (in seconds) of clip (trim start of video) More...
virtual | ~ClipBase ()=default

## Public Attributes

Keyframe | amplitude
| The height of the wave. More...
Keyframe | multiplier
| Amount to multiply the wave (make it bigger) More...
Keyframe | shift_x
| Amount to shift X-axis. More...
Keyframe | speed_y
| Speed of the wave on the Y-axis. More...
Keyframe | wavelength
| The length of the wave. More...
Public Attributes inherited from openshot::EffectBase
EffectInfoStruct | info
| Information about the current effect. More...

## Additional Inherited Members

Protected Member Functions inherited from openshot::ClipBase
Json::Value | add_property_choice_json (std::string name, int value, int selected_value) const
| Generate JSON choice for a property (dropdown properties) More...
Json::Value | add_property_json (std::string name, float value, std::string type, std::string memo, const Keyframe *keyframe, float min_value, float max_value, bool readonly, int64_t requested_frame) const
| Generate JSON for a property. More...
Protected Attributes inherited from openshot::ClipBase
float | end
| The position in seconds to end playing (used to trim the ending of a clip) More...
std::string | id
| ID Property for all derived Clip and Effect classes. More...
int | layer
| The layer this clip is on. Lower clips are covered up by higher clips. More...
float | position
| The position on the timeline where this clip should start playing. More...
std::string | previous_properties
| This string contains the previous JSON properties. More...
float | start
| The position in seconds to start playing (used to trim the beginning of a clip) More...

## Detailed Description

This class distorts an image using a wave pattern.

Distoring an image with a wave can be used to simulate analog transmissions, and other effects, and each value of the wave computation can be animated with an openshot::Keyframe curves over time.

Definition at line 52 of file Wave.h.

## Constructor & Destructor Documentation

## Wave() [1/2]

Wave::Wave | ( |  | ) |

Blank constructor, useful when using Json to load the effect properties.

Definition at line 36 of file Wave.cpp.

## Wave() [2/2]

Wave::Wave | ( | Keyframe | wavelength,
|  | Keyframe | amplitude,
|  | Keyframe | multiplier,
|  | Keyframe | shift_x,
|  | Keyframe | speed_y
| ) |  |

Default constructor, which takes 5 curves. The curves will distort the image.

Parameters

  wavelength | The curve to adjust the wavelength (0.0 to 3.0)
  amplitude | The curve to adjust the amplitude (0.0 to 5.0)
  multiplier | The curve to adjust the multiplier (0.0 to 1.0)
  shift_x | The curve to shift pixels along the x-axis (0 to 100)
  speed_y | The curve to adjust the vertical speed (0 to 10)

Definition at line 42 of file Wave.cpp.

## Member Function Documentation

## GetFrame()

std::shared_ptr< Frame > Wave::GetFrame | ( | std::shared_ptr< Frame > | frame,
|  | int64_t | frame_number
| ) |  |

virtual

This method is required for all derived classes of EffectBase, and returns a modified openshot::Frame object.

The frame object is passed into this method, and a frame_number is passed in which tells the effect which settings to use from its keyframes (starting at 1).

Returns
  The modified openshot::Frame object

Parameters

  frame | The frame object that needs the effect applied to it
  frame_number | The frame number (starting at 1) of the effect on the timeline.

Implements openshot::EffectBase.

Definition at line 66 of file Wave.cpp.

## Json()

std::string Wave::Json | ( |  | ) | const

override virtual

Get and Set JSON methods.

Generate JSON string of this object

Implements openshot::EffectBase.

Definition at line 112 of file Wave.cpp.

## JsonValue()

Json::Value Wave::JsonValue | ( |  | ) | const

override virtual

Generate Json::Value for this object.

Implements openshot::EffectBase.

Definition at line 119 of file Wave.cpp.

Referenced by Json().

## PropertiesJSON()

std::string Wave::PropertiesJSON | ( | int64_t | requested_frame | ) | const

override virtual

Get all properties for a specific frame (perfect for a UI to display the current state of all properties at any time)

Implements openshot::ClipBase.

Definition at line 171 of file Wave.cpp.

## SetJson()

void Wave::SetJson | ( | const std::string | value | ) |

virtual

Load JSON string into this object.

Implements openshot::EffectBase.

Definition at line 135 of file Wave.cpp.

## SetJsonValue()

void Wave::SetJsonValue | ( | const Json::Value | root | ) |

virtual

Load Json::Value into this object.

Implements openshot::EffectBase.

Definition at line 152 of file Wave.cpp.

Referenced by SetJson().

## Member Data Documentation

## amplitude

Keyframe openshot::Wave::amplitude

The height of the wave.

Definition at line 62 of file Wave.h.

Referenced by GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## multiplier

Keyframe openshot::Wave::multiplier

Amount to multiply the wave (make it bigger)

Definition at line 63 of file Wave.h.

Referenced by GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## shift_x

Keyframe openshot::Wave::shift_x

Amount to shift X-axis.

Definition at line 64 of file Wave.h.

Referenced by GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## speed_y

Keyframe openshot::Wave::speed_y

Speed of the wave on the Y-axis.

Definition at line 65 of file Wave.h.

Referenced by GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## wavelength

Keyframe openshot::Wave::wavelength

The length of the wave.

Definition at line 61 of file Wave.h.

Referenced by GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

The documentation for this class was generated from the following files:

- Wave.h
- Wave.cpp